#ifndef _ARM_DELAY_H
#define _ARM_DELAY_H

/*
 * Copyright (C) 1994 R.M.King
 *
 * Delay routines, using a pre-computed "loops_per_second" value.
 */

extern void __delay(int loops);

/*
 * division by multiplication: you don't have to worry about
 * loss of precision.
 *
 * Use only for very small delays ( < 1 msec).  Should probably use a
 * lookup table, really, as the multiplications take much too long with
 * short delays.  This is a "reasonable" implementation, though (and the
 * first constant multiplications gets optimized away if the delay is
 * a constant)
 */
extern void udelay(unsigned long usecs);

#endif
