#ifndef _ASM_SEGMENT_H
#define _ASM_SEGMENT_H

extern unsigned char get_user_byte(const char *addr);

#define get_fs_byte(addr) get_user_byte((char *)(addr))

extern unsigned short get_user_word(const short *addr);

#define get_fs_word(addr) get_user_word((short *)(addr))

extern unsigned long get_user_long(const int *addr);

#define get_fs_long(addr) get_user_long((int *)(addr))

extern void put_user_byte(char val,char *addr);

#define put_fs_byte(x,addr) put_user_byte((x),(char *)(addr))

extern void put_user_word(short val,short *addr);

#define put_fs_word(x,addr) put_user_word((x),(short *)(addr))

extern void put_user_long(unsigned long val,int *addr);

#define put_fs_long(x,addr) put_user_long((x),(int *)(addr))

extern void memcpy_tofs(void *to,const void *from,unsigned long n);

extern void memcpy_fromfs(void *to,const void *from,unsigned long n);

#endif
