#ifndef __ASM_SYSTEM_H
#define __ASM_SYSTEM_H

/*
 * Change processor mode to user mode
 */

void move_to_user_mode(void);

/*
 * Disable interrupts
 */

void cli(void);

/*
 * Enable interrupts
 */

void sti(void);

/*
 * Execute a no-op
 */

/* void nop(void); */

/*
 * Purpose: Save flag status into a variable
 */

void __save_flags(unsigned long *where);

/*
 * Purpose: Restore flag status from a variable
 */

void __restore_flags(unsigned long *where);

#define save_flags(/* unsigned long */where)\
  __save_flags(&(where))
#define restore_flags(/* unsigned long */where)\
  __restore_flags(&(where))

#endif
